# LEGENDE: WTZ = wildtype im Zaehler, MTZ = mutated im Zaehler
#	library(Biostrings) #needs to be commented out to run with TalkwithR_original.pl
#	library(MotifDb) #needs to be commented out to run with TalkwithR_original.pl
#	library("klaR") #needs to be commented out to run with TalkwithR_original.pl
#	rm(list = ls()) #needs to be commented out to run with TalkwithR_original.pl
TF=NULL
mat=NULL
db=NULL
score_wt=NULL
score_mt=NULL
startpos_wt=NULL
endpos_wt=NULL
startpos_mt=NULL
endpos_mt=NULL
maxstrand=NULL
maxstrand_mt=NULL
wtzquot=NULL
mtzquot=NULL

database <- c("hPDI", "JASPAR_2014", "Jolma2013")
#database <- "JASPAR_2014" #needs to be commented out to run with TalkwithR_original.pl
#tf <- "IRF1" #needs to be commented out to run with TalkwithR_original.pl
#wt <- "ATGCCTGTAAGCTGTCCT" #needs to be commented out to run with TalkwithR_original.pl
#mt <- "ATTTTTTTTTTTTTTCTTG" #needs to be commented out to run with TalkwithR_original.pl
 
for (i in 1:length(database)) {   
	res <- query (query (query(MotifDb, "hsapiens"), tf), database[i])
 	if (length(res) == "0") {next}
 	for (j in 1:length(res)) {
		if(database[i] == "JASPAR_2014") {
			if(tf != "JUN" && tf != "JUND" && tf !=  "EBF1" && tf !=   "NFIC" && tf !=   "RXRA" && tf !=   "MAX" && tf !=  "STAT1" && tf != "NFE2"){
				if(j == 1) {m <- j}
				if(j >= 2) {next}
			}
			if(tf == "JUN") {
				if(j==1) {next}
				if(j==2) {m <- (j-1)}
				if(j==3) {m <- (j-1)}
				if(j > 3) {next}		
			}
			if(j == 2 & tf == "EBF1") {next}
			if((tf == "NFIC") || (tf == "MAX") || (tf == "STAT1")) {
				if(j==1) {next}
				if(j==2) {m <- (j-1)}
			}
			if(tf == "RXRA" || tf == "ELK1" || tf == "ELK4" || tf=="NFE2" || tf=="TCF3") {next}
			if(tf == "JUND") {m <- j}			
		}
		if(database[i] == "hPDI") {
			if(tf=="FOS"||tf=="NFYB"||tf=="SP2"||tf=="SRF") {next}
			else {m <- j}
   		}
		
		if(database[i] == "Jolma2013") {m <- j}
		pfm <- res[[j]]
		pcm <- round(100*pfm)
    		
		#check wt
		seq_wt <- as.character(wt) 

		hits_wt <- matchPWM(pcm, seq_wt,"20%",with.score=TRUE)
    	rev_hits_wt <- matchPWM(reverseComplement(pcm), seq_wt, "20%", with.score=TRUE)
		hit_scores_wt <- mcols(hits_wt)$score/maxScore(pcm)
    	rev_scores_wt <- mcols(rev_hits_wt)$score/maxScore(pcm)
		# getting maxscores and positions: 
		if (nrow(mcols(hits_wt)) != 0) {
			max_ind_pos <- match(max(mcols(hits_wt)$score), mcols(hits_wt)$score)
			max_pos_wt <- max(hit_scores_wt)
			start_pos_wt <- start(hits_wt[max_ind_pos])
			end_pos_wt <- end(hits_wt[max_ind_pos])
		} else {
			max_pos_wt <- 0
			start_pos_wt <- "no-match-found"
			end_pos_wt <- "no-match-found"
		}
		
		if (nrow(mcols(rev_hits_wt)) != 0) {
			max_ind_rev <- match(max(mcols(rev_hits_wt)$score), mcols(rev_hits_wt)$score)
			max_rev_wt <- max(rev_scores_wt)
			start_rev_wt <- start(rev_hits_wt[max_ind_rev])
			end_rev_wt <- end(rev_hits_wt[max_ind_rev])
		} else {
			max_rev_wt <- 0			
			start_rev_wt <-"no-match-found"
			end_rev_wt <- "no-match-found"
		}

		if (max_pos_wt == max_rev_wt){
			abs_max_wt <- max_pos_wt
			abs_start_wt <- start_pos_wt
			abs_end_wt <- end_pos_wt
			strand_wt <- "both"
		} 	else 
		if (max_pos_wt > max_rev_wt) {
			abs_max_wt <- max_pos_wt
			abs_start_wt <- start_pos_wt
			abs_end_wt <- end_pos_wt
			strand_wt <- "plus"
		} else {
			abs_max_wt <- max_rev_wt
			abs_start_wt <- start_rev_wt
			abs_end_wt <- end_rev_wt
			strand_wt <- "minus"
		}
			
		#check mt (if defined)
			
		if (exists("mt")) {	
			seq_mt <- as.character(mt)
	  		hits_mt <- matchPWM(pcm, seq_mt,"20%",with.score=TRUE)
	    		rev_hits_mt <- matchPWM(reverseComplement(pcm), seq_mt, "20%", with.score=TRUE)
			hit_scores_mt <- mcols(hits_mt)$score/maxScore(pcm)
    			rev_scores_mt <- mcols(rev_hits_mt)$score/maxScore(pcm)
			# getting maxscores and positions: 
			if (nrow(mcols(hits_mt)) != 0) {
				max_ind_pos_mt <- match(max(mcols(hits_mt)$score), mcols(hits_mt)$score)
				max_pos_mt <- max(hit_scores_mt)
				start_pos_mt <- start(hits_mt[max_ind_pos_mt])
				end_pos_mt <- end(hits_mt[max_ind_pos_mt])
			} else {
				max_pos_mt <- 0	
				start_pos_mt <- "no-match-found"
				end_pos_mt <- "no-match-found"
			} 
			
			if (nrow(mcols(rev_hits_mt)) != 0) {
				max_ind_rev_mt <- match(max(mcols(rev_hits_mt)$score), mcols(rev_hits_mt)$score)
				max_rev_mt <- max(rev_scores_mt)
				start_rev_mt <- start(rev_hits_mt[max_ind_rev_mt])
				end_rev_mt <- end(rev_hits_mt[max_ind_rev_mt])
			} else {
				max_rev_mt <- 0	
				start_rev_mt <- "no-match-found"
				end_rev_mt <- "no-match-found"
								
			}
				# which score is higher?
			
			if (max_pos_mt == max_rev_mt){
				abs_max_mt <- max_pos_mt
				abs_start_mt <- start_pos_mt
				abs_end_mt <- end_pos_mt
				strand_mt <- "both"
			} else 
			if (max_pos_mt > max_rev_mt) {
				abs_max_mt <- max_pos_mt
				abs_start_mt <- start_pos_mt
				abs_end_mt <- end_pos_mt
				strand_mt <- "plus"
			} else {
				abs_max_mt <- max_rev_mt
				abs_start_mt <- start_rev_mt
				abs_end_mt <- end_rev_mt
				strand_mt <- "minus"
			}
		} else {
			abs_max_mt <- "not-tested"
			abs_start_mt <- "not-tested"
			abs_end_mt <- "not-tested"
			strand_mt <- "not-tested"
		}    
    
		if (abs_max_mt != "not-tested") {
		
      if (abs_max_mt != 0 && abs_max_wt != 0) {
        wt_z_q <- abs_max_wt/abs_max_mt
        mt_z_q <- abs_max_mt/abs_max_wt
			} else 
        if (abs_max_mt == 0 && abs_max_wt != 0) {
          wt_z_q <- NA
          mt_z_q <- abs_max_mt/abs_max_wt
      } else
          if (abs_max_wt == 0 && abs_max_mt != 0) {
            wt_z_q <- abs_max_wt/abs_max_mt
            mt_z_q <- NA
          } else
        if (abs_max_wt == 0 && abs_max_mt == 0) {
          wt_z_q <- NA
          mt_z_q <- NA
        }
      
  		} else {
			wt_z_q <- "not-tested"
			mt_z_q <- "not-tested"
		}		
		
     	#filling the vectors
		TF = append(TF, tf)
		mat = append(mat, m)
		db = append(db, database[i])
		score_wt = append(score_wt, abs_max_wt)
		score_mt = append(score_mt,abs_max_mt)
		startpos_wt =append(startpos_wt, abs_start_wt)
		endpos_wt =append(endpos_wt, abs_end_wt)
		startpos_mt =append(startpos_mt, abs_start_mt)
		endpos_mt =append(endpos_mt, abs_end_mt)
		maxstrand = append(maxstrand, strand_wt)
		maxstrand_mt = append(maxstrand_mt, strand_mt)
		wtzquot = append(wtzquot, wt_z_q)
		mtzquot = append(mtzquot, mt_z_q)
	}
}

result = data.frame(TF,mat,db,score_wt,score_mt, startpos_wt, endpos_wt, startpos_mt, endpos_mt, maxstrand, maxstrand_mt, wtzquot, mtzquot)

if (exists("mt")) {
# empty vectors for df
	TF_b=NULL
	mat_b=NULL
	db_b=NULL
	pred_wtz = NULL
	maxscore_wt = NULL
	maxscore_mt = NULL
	startpos_wt_b=NULL
	endpos_wt_b=NULL
	startpos_mt_b=NULL
	endpos_mt_b=NULL
	maxstrand_b=NULL
	maxstrand_b_mt=NULL
	bayesscore_gain = NULL
	wtzquot_b=NULL
	mtzquot_b=NULL


	for (k in 1:length(result$db)) {

		if(result$db[k]=="hPDI") {
			base <- "hPDI"
			mate <- 0
			}
		if(result$db[k]=="JASPAR_2014") {
			base <- "Jaspar"
			mate <- result$mat[k]
		  }
		if(result$db[k]=="Jolma2013") {
			base <- "HT-SELEX"
			mate <- result$mat[k]
			}
		filename <- paste("/data/bioinformatics/TFBS_tool_collection/klar/Quotient/Training/",base,"_",tf,"_mat",mate,"_klar_train.RData", sep="") 			

    
		naiveTrain <- readRDS(filename)

   if (!is.na(result$wtzquot[k])) {
	    bayes_wtz <- predict(naiveTrain,result[k,12, drop=FALSE], usekernel=T)
      #  	bayes_wt <- predict(naiveTrain,result[k,4, drop=FALSE], usekernel=T)
	  	bayes_pred_wtz <- bayes_wtz$class
	  	bayes_pred_wtz <- as.character(bayes_pred_wtz)
	  	bscore_gain <- as.character(bayes_wtz$posterior[2])
		# to account for mixed-up scorequotients
		if (bayes_pred_wtz == "gain") {
			bayes_pred_wtz <- "loss"
		} else 
		if (bayes_pred_wtz == "loss") {
			bayes_pred_wtz <- "gain"
		}
  #bayes_gain$posterior : ACHTUNG!! IST ABER VERKEHRT HERUM WEGEN VERTAUSCHTER SCOREQUOTIENTEN!!!
	#gain      loss
  	#(1=gain, 2=loss)
	} else  
  if (is.na(result$wtzquot[k]) && !is.na(result$mtzquot[k])) {
    bayes_pred_wtz <- "gain"
    bscore_gain <- "not-tested"
  } else
  if (is.na(result$wtzquot[k]) && is.na(result$mtzquot[k])) {
    bayes_pred_wtz <- "no-match" # this doesn't work yet... Maybe!!
    bscore_gain <- "not-tested"
  }
  
  
  if (is.na(result$mtzquot[k]) && !is.na(result$wtzquot[k])) {
      bayes_pred_wtz <- "loss"
      bscore_gain <- "not-tested"
    }
	
	# cross-validation:
	#randomize data
	#dat_rand <- dat[order(runif(nrow(dat))),]
	#define train and test sets: train=90%, test=10%	
	#train <- dat_rand[1:(length(dat_rand[,1])*0.9),]
	#test <- dat_rand[(length(train[,1])+1):length(dat_rand[,1]),]
	#define and test with entire testset
 	#train <- dat_rand
 	#test <- dat_rand
				
	
	# appending to vectors to save in df later 

		TF_b = append(TF_b, as.character(result$TF[k]))
		mat_b = append(mat_b, as.character(result$mat[k]))
		db_b = append(db_b, as.character(result$db[k]))
		maxscore_wt = append(maxscore_wt, as.character(result$score_wt[k]))
		maxscore_mt = append(maxscore_mt, as.character(result$score_mt[k]))
		pred_wtz = append(pred_wtz, bayes_pred_wtz)
		startpos_wt_b =append(startpos_wt_b, as.character(result$startpos_wt[k])) 
		endpos_wt_b =append(endpos_wt_b, as.character(result$endpos_wt[k]))
		startpos_mt_b =append(startpos_mt_b, as.character(result$startpos_mt[k]))
		endpos_mt_b =append(endpos_mt_b, as.character(result$endpos_mt[k]))
		maxstrand_b=append(maxstrand_b, as.character(result$maxstrand[k]))
		maxstrand_b_mt=append(maxstrand_b_mt, as.character(result$maxstrand_mt[k]))
		bayesscore_gain = append(bayesscore_gain, bscore_gain)
		wtzquot_b = append(wtzquot_b, as.character(result$wtzquot[k]))
	 }
	bayes_result = data.frame(TF_b, mat_b,db_b,maxscore_wt, maxscore_mt, startpos_wt_b, endpos_wt_b, startpos_mt_b, endpos_mt_b, maxstrand_b, maxstrand_b_mt, pred_wtz, bayesscore_gain,wtzquot_b)
	#write.table(bayes_result, append=F, sep=",", row.names=F, col.names=T)
} else {bayes_result <- "no-bayestest"}